/* SampleLookup.c  Version 2.0
    Copyright 1990 Jeremy Grodberg.  All Rights Reserved
 
These functions demonstrate how a cdev might use this library to get its INIT's
storage.  They assume, of course, that the INIT has registered the address of its
globals with the library, as explained in SampleINIT.a and RegisterWithGestalt.a.

*/

/* use whatever mac headers you need */
#include <macheaders>


/* include the Gestalt defines in case the development system doesn't have them */

#ifndef gestaltUnknownErr

#define gestaltUnknownErr 			 	-5550 	/* gestalt doesn't know the answer				*/
#define gestaltUndefSelectorErr   -5551 	/* undefined code was passed to Gestalt 	*/
#define gestaltDupSelectorErr 	 	-5552 	/* tried to overwrite an existing entry 	*/
#define gestaltLocationErr 				-5553 	/* gestalt function ptr wasn't in sysheap	*/

#endif



#define TheSignature '????'   /* the INIT's signature */

#define GestaltTrap			0xA1AD
#define Unimplemented		0xA89F

typedef struct MyGlobalsRec {  /* the structure of the inits globals */
	Boolean	disabled;  			/* set to true to turn off INIT */
	short		beepDuration;
	Ptr			resumeAddr;
	} *globalsPtr;

/************************************************************************************* 
	GetGlobals sets theGlobals to point to the INITs storage.  It returns false if
  if fails for some reason.
*************************************************************************************/
Boolean GetGlobals(globalsPtr *theGlobals)  
{		
		return (noErr == LookupMySignature(TheSignature, (long *) theGlobals));
};


/************************************************************************************* 
	TurnOffINIT Gets the INITs globals and sets the disabled flag.  You could
	likewise change any operating parameter of the INIT, from your cdev or APPL.
*************************************************************************************/

void TurnOffINIT(void)
{
	globalsPtr theGlobals;

	/* edit the global resource so that the INIT will be disabled on restart */
	
	/* ... left as an exercise for the reader ... */
	
	/* turn the INIT off right now */
	if (GetGlobals(&theGlobals))   /* if we can get the INIT's globals */
		theGlobals->disabled = true; /* Turn the INIT off */
	
};

